﻿Imports System.Drawing

Public Class Form1

    Private wfp As WaveFilePlayer = New WaveFilePlayer
    Private Slot_Input As Int32
    Private Slot_InputChange As Int32
    Private Slot_Output As Int32
    Private Slot_OutputChange As Int32
    Private Slot_Pan As Int32
    Private Slot_VolUp As Int32
    Private Slot_VolDw As Int32
    Private Slot_FilterFreq As Int32
    Private Slot_FilterRes As Int32
    Private Slot_EchoVolume As Int32
    Private Slot_EchoFbk As Int32
    Private ChangeFile As Boolean
    Private ChangeRandom As Boolean
    Private TriggerStarted As Boolean = False

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Randomize()
        Dim s As String
        s = IO.Path.GetFileNameWithoutExtension(Application.StartupPath)
        If s.ToLower = "bin" Then
            s = IO.Path.GetFileNameWithoutExtension(IO.Directory.GetParent(Application.StartupPath).ToString)
        End If
        Text = AppTitleAndVersion("Theremino SndPlayer")
        Me.Text &= "  ( " & s & " )"
        ToolTips_Init()
        FillComboWithFileNames()
        cmb_PinType_IntTypes()
        Load_INI()
        EventsAreEnabled = True
        If cmb_WaveFiles.SelectedIndex < 0 Then Combo_SetIndex(cmb_WaveFiles, 0)
        If cmb_FilterType.SelectedIndex < 0 Then Combo_SetIndex(cmb_FilterType, 0)
        Timer1.Interval = 10
        Timer2.Interval = 200
        Timer2.Start()
        Set_SlotProps()
        Set_MainProps()
        Set_StereoEnable()
        Set_OutProps()
        Set_FilterEnable()
        Set_FilterProps()
        Set_EchoEnable()
        Set_EchoProps()
        PlayStart()
        ' ----------------------------------------------------------------------- set affinity
        'Dim Proc As Process = Process.GetCurrentProcess()
        'For i As Int32 = 0 To Proc.Threads.Count
        '    Dim Thread As ProcessThread = Proc.Threads(0)
        '    Dim AffinityMask As Int32 = 1  ' first processor
        '    Thread.ProcessorAffinity = CType(AffinityMask, IntPtr)
        'Next

        ' -------------------------------------------------------------------------------
        ' REAL-TIME
        ' -------------------------------------------------------------------------------
        'System.Threading.Thread.CurrentThread.Priority = System.Threading.ThreadPriority.Normal
        'System.Diagnostics.Process.GetCurrentProcess().PriorityClass = ProcessPriorityClass.RealTime
        ' ------------------------------------------------------------------ 
        'SchedulerMaxPrecision()
        Refresh()
        Opacity = 1
    End Sub

    Private Sub Form_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.FormClosing
        PlayStop()
        Save_INI()
        'SchedulerDefaultPrecision
    End Sub

    Private Sub Me_LocationChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub

    ' =========================================================================
    '  WINDOWS SCHEDULER PRECISION
    ' ========================================================================= 
    'Private Declare Function timeBeginPeriod Lib "winmm.dll" (ByVal uPeriod As Int32) As Int32
    'Private Declare Function timeEndPeriod Lib "winmm.dll" (ByVal uPeriod As Int32) As Int32
    'Private Sub SchedulerMaxPrecision()
    '    timeBeginPeriod(1)
    'End Sub
    'Private Sub SchedulerDefaultPrecision()
    '    timeEndPeriod(1)
    'End Sub


    ' ==============================================================================================================
    '   ToolTips
    ' ==============================================================================================================
    Private ttp1 As ToolTip
    Private Sub ToolTips_Init()
        ttp1 = New ToolTip
        ttp1.ShowAlways = True
        ttp1.UseAnimation = True
        ttp1.UseFading = True
        ttp1.IsBalloon = True
        ttp1.AutoPopDelay = 32700
        ttp1.InitialDelay = 500
        ttp1.ReshowDelay = 500
        ' --------------------------------------------------------------- Add here Controls and ToolTip-Text
        ttp1.SetToolTip(txt_SlotIn, _
                        "Input Slot ( input )" & vbCr & _
                        "-------------------------------------" & vbCr & _
                        "The audio position is controlled" & vbCr & _
                        "by this slot with a float value" & vbCr & _
                        "ranging from 0.0 to 1000.0")

        ttp1.SetToolTip(txt_SlotInChange, _
                        "Change Slot ( input )" & vbCr & _
                        "-------------------------------------" & vbCr & _
                        "The current file index is controlled" & vbCr & _
                        "by this slot with a number" & vbCr & _
                        "ranging from 1 to number audio files")

        ttp1.SetToolTip(txt_SlotOut, _
                        "Output Slot  ( output )" & vbCr & _
                        "-------------------------------------" & vbCr & _
                        "The current audio position is written" & vbCr & _
                        "to this slot as a float value from 0.0" & vbCr & _
                        "to 1000.0 to control other devices.")

        ttp1.SetToolTip(txt_SlotOutChange, _
                        "Change Slot ( output )" & vbCr & _
                        "-------------------------------------" & vbCr & _
                        "The current file index is written" & vbCr & _
                        "to this slot to control other devices.")
    End Sub


    ' =======================================================================================
    '   COMBO WAVE FILES
    ' =======================================================================================
    Private Sub cmb_WaveFiles_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_WaveFiles.DropDown
        FillComboWithFileNames()
        Combo_SetIndex_FromString(cmb_WaveFiles, wfp.FileName)
    End Sub
    Private Sub cmb_WaveFiles_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_WaveFiles.DropDownClosed
        TriggerStarted = False
        PlayStart()
    End Sub
    Private Sub cmb_WaveFiles_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_WaveFiles.SelectedIndexChanged
        If Not EventsAreEnabled Then Exit Sub
        If cmb_WaveFiles.SelectedIndex < 0 Then Exit Sub
        Save_INI()
    End Sub
    Private Sub FillComboWithFileNames()
        ReadWaveFileNames()
        If WaveFileNames Is Nothing Then Return
        cmb_WaveFiles.Items.Clear()
        For Each f As String In WaveFileNames
            cmb_WaveFiles.Items.Add(My.Computer.FileSystem.GetName(f))
        Next
    End Sub

    Private Sub OpenNextFile()
        Dim i As Int32 = -1
        ReadWaveFileNames()
        If WaveFileNames.Count = 0 Then Return
        If ChangeRandom Then
            i = CInt(Rnd() * (WaveFileNames.Count - 1))
        Else
            For Each f As String In WaveFileNames
                If cmb_WaveFiles.Text = My.Computer.FileSystem.GetName(f) Then
                    i = WaveFileNames.IndexOf(f)
                End If
            Next
            i += 1
            If i >= WaveFileNames.Count Then i = 0
        End If

        Dim s As String = My.Computer.FileSystem.GetName(WaveFileNames(i))
        Combo_SetIndex_FromString(cmb_WaveFiles, s)
    End Sub

    Private Sub OpenAudioFile(ByVal i As Int32)
        ReadWaveFileNames()
        If WaveFileNames.Count = 0 Then Return

        If i < 0 Then i = 0
        If i >= WaveFileNames.Count Then i = WaveFileNames.Count - 1

        Dim s As String = My.Computer.FileSystem.GetName(WaveFileNames(i))
        Combo_SetIndex_FromString(cmb_WaveFiles, s)
    End Sub


    ' ================================================================================================
    '   PLAY / STOP - BUTTONS
    ' ================================================================================================
    Private Sub chk_Play_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_Play.CheckedChanged
        If Not EventsAreEnabled Then Exit Sub
        If chk_Play.Checked Then
            PlayStart()
        Else
            PlayStop()
        End If
    End Sub

    Private Sub PlayStart()
        ' ----------------------------------------------------------------- OUTPUT CHANGE
        If Slot_OutputChange >= 0 Then
            Slots.WriteSlot(Slot_OutputChange, cmb_WaveFiles.SelectedIndex)
        End If
        ' -----------------------------------------------------------------
        If chk_Play.Checked Then
            If TabControl1.SelectedTab Is TabPageTrigger Then

                'TODO (to make the way "Trigger" identical to "Pisces Poets")
                'Add the parameter of time from the previous sound.
                'Instantiate a new wfp for each sound up to eight contemporary sounds.
                'Terminate the wfp at the end of sound

                wfp.PlayStart(cmb_WaveFiles.Text, chk_Stereo.Checked, True, False, True) ' LowQuality
                'wfp.PlayStart(cmb_WaveFiles.Text, chk_Stereo.Checked, True, True, True) ' HiQuality
            Else
                wfp.PlayStart(cmb_WaveFiles.Text, chk_Stereo.Checked, False, True, chk_Looping.Checked)
            End If
        End If
    End Sub

    Private Sub PlayStop()
        TriggerStarted = False
        wfp.PlayStop()
    End Sub

    Private Sub PlayPause()
        TriggerStarted = False
        wfp.PlayPause()
    End Sub


    ' ================================================================================================
    '    TIMERS
    ' ================================================================================================
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        wfp.TimedUpdate()
        UpdateWavePositionBar()

        If TabControl1.SelectedTab Is TabPageTrigger Then

            ' ------------------------------------------------------------- TRIGGER MODE
            Static oldInput As Single
            Dim change As Single
            Dim Sensitivity As Single = 0.002F * txt_TrigSensitivity.NumericValueInteger
            If Slot_Input >= 0 Then
                Dim n As Single = Slots.ReadSlot_NoNan(Slot_Input)
                oldInput += (n - oldInput) * 0.1F
                change = CSng(Math.Abs(n - oldInput) * Sensitivity)
                If change > 1 Then
                    oldInput += (n - oldInput) * 0.5F
                End If
            Else
                change = tk_Position.Value / 10000.0F
            End If
            If change > 1 Then change = 1
            If change < 0 Then change = 0

            tk_Position.Value = CInt(change * 10000)

            If Not TriggerStarted Then
                If change > 0.8 Then
                    Dim s As Double
                    s = (txt_PlaySpeed.NumericValue + (Rnd() - 0.5) * txt_PlaySpeedRandom.NumericValue)
                    If s < txt_PlaySpeedMin.NumericValue Then s = txt_PlaySpeedMin.NumericValue
                    If s > 99 Then s = 99
                    wfp.Frequency = CSng(s)
                    TriggerStarted = True
                    'If wfp.ReachedTheEnd Then
                    '    PlayStart()
                    'End If
                End If
            End If

            If wfp.ReachedTheEnd Then
                PlayPause()
            End If

            ' ---------------------------------------- Auto Change
            If ChangeFile Then
                If wfp.ReachedTheEnd Then
                    PlayPause()
                    OpenNextFile()
                    PlayStart()
                    oldInput = Slots.ReadSlot_NoNan(Slot_Input)
                End If
            End If
            wfp.ReachedTheEnd = False

        Else

            ' ------------------------------------------------------------- FOLLOW MODE
            If Slot_Input >= 0 Then
                Dim n As Single = Slots.ReadSlot_NoNan(Slot_Input) / 1000.0F
                If n > 1 Then n = 1
                If n < 0 Then n = 0
                tk_Position.Value = CInt(n * 10000)
                Set_DesiredPos()
            End If

            ' ------------------------------------------- Auto Change
            Static AutoChangeEnabled As Boolean = False
            If ChangeFile Then
                If AutoChangeEnabled Then
                    If wfp.PositionNormalized < 0.05 Then
                        AutoChangeEnabled = False
                        PlayPause()
                        OpenNextFile()
                        PlayStart()
                    End If
                Else
                    If wfp.PositionNormalized > 0.1 Then
                        AutoChangeEnabled = True
                    End If
                End If
            End If

        End If


        ' ----------------------------------------------------------------- INPUT CHANGE
        If Slot_InputChange >= 0 Then
            Dim n As Int32 = CInt(Slots.ReadSlot_NoNan(Slot_InputChange))
            Static oldindex1 As Int32 = -1
            If n <> oldindex1 Then
                oldindex1 = n
                PlayPause()
                OpenAudioFile(n)
                PlayStart()
            End If
        End If
        ' ----------------------------------------------------------------- OUTPUT 
        If Slot_Output >= 0 Then
            Slots.WriteSlot(Slot_Output, CSng(wfp.PositionNormalized) * 1000.0F)
        End If
        ' ----------------------------------------------------------------- PAN
        If Slot_Pan >= 0 Then
            If tk_Pan.Enabled Then
                Dim n As Single = Slots.ReadSlot_NoNan(Slot_Pan) / 1000.0F
                If n > 1 Then n = 1
                If n < 0 Then n = 0
                tk_Pan.Value = CInt(n * 10000)
                wfp.Pan = n * 2 - 1
            End If
        End If
        ' ----------------------------------------------------------------- VOL UP
        If Slot_VolUp >= 0 Then
            Dim n As Single = Slots.ReadSlot_NoNan(Slot_VolUp) / 1000.0F
            If n > 1 Then n = 1
            If n < 0 Then n = 0
            tk_VolumeUP.Value = CInt(n * 10000)
            wfp.VolumeUP = n
        End If
        ' ----------------------------------------------------------------- VOL DW
        If Slot_VolDw >= 0 Then
            Dim n As Single = Slots.ReadSlot_NoNan(Slot_VolDw) / 1000.0F
            If n > 1 Then n = 1
            If n < 0 Then n = 0
            tk_VolumeDW.Value = CInt(n * 10000)
            wfp.VolumeDW = n
        End If
        ' ----------------------------------------------------------------- FILTER FREQUENCY
        If Slot_FilterFreq >= 0 Then
            Dim n As Single = Slots.ReadSlot_NoNan(Slot_FilterFreq) / 1000.0F
            If n > 1 Then n = 1
            If n < 0 Then n = 0
            tk_FilterFreq.Value = CInt(n * 10000)
            wfp.Effects.SetFilterFrequency(n)
        End If
        ' ----------------------------------------------------------------- FILTER RESONANCE
        If Slot_FilterRes >= 0 Then
            Dim n As Single = Slots.ReadSlot_NoNan(Slot_FilterRes) / 1000.0F
            If n > 1 Then n = 1
            If n < 0 Then n = 0
            tk_FilterRes.Value = CInt(n * 10000)
            wfp.Effects.SetFilterResonance(n)
        End If
        ' ----------------------------------------------------------------- ECHO VOLUME
        If Slot_EchoVolume >= 0 Then
            Dim n As Single = Slots.ReadSlot_NoNan(Slot_EchoVolume) / 1000.0F
            If n > 1 Then n = 1
            If n < 0 Then n = 0
            tk_EchoVolume.Value = CInt(n * 10000)
            wfp.Effects.SetEchoVolume(n)
        End If
        ' ----------------------------------------------------------------- ECHO FEEDBACK
        If Slot_EchoFbk >= 0 Then
            Dim n As Single = Slots.ReadSlot_NoNan(Slot_EchoFbk) / 1000.0F
            If n > 1 Then n = 1
            If n < 0 Then n = 0
            tk_EchoFbk.Value = CInt(n * 10000)
            wfp.Effects.SetEchoFeedback(n)
        End If
    End Sub

    Friend Sub UpdateWavePositionBar()
        FillPictureBoxVertical(pBox1, wfp.PositionNormalized, Color.MintCream, Color.Orange)
    End Sub

    Private Sub Timer2_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer2.Tick
        LabelTime.Text = wfp.BufferFillTimeMicrosec.ToString & " uS"
    End Sub


    ' ================================================================================================
    '   SAVE INI ON LOST-FOCUS
    ' ================================================================================================
    Private Sub Properties_LostFocus(ByVal sender As Object, _
                                     ByVal e As System.EventArgs) Handles txt_SlotIn.LostFocus, _
                                                                            txt_SlotInChange.LostFocus, _
                                                                            txt_SlotOut.LostFocus, _
                                                                            txt_SlotOutChange.LostFocus, _
                                                                            txt_SlotPan.LostFocus, _
                                                                            txt_SlotVolUp.LostFocus, _
                                                                            txt_SlotVolDw.LostFocus, _
                                                                            txt_SlotFilterFreq.LostFocus, _
                                                                            txt_SlotFilterRes.LostFocus, _
                                                                            txt_SlotEchoVolume.LostFocus, _
                                                                            txt_SlotEchoFbk.LostFocus, _
                                                                            tk_Position.LostFocus, _
                                                                            chk_Change.LostFocus, _
                                                                            chk_Random.LostFocus, _
                                                                            txt_ResponseSpeed.LostFocus, _
                                                                            txt_Margin.LostFocus, _
                                                                            txt_MaxSpeedUP.LostFocus, _
                                                                            txt_MaxSpeedDW.LostFocus, _
                                                                            chk_Follow.LostFocus, _
                                                                            chk_Looping.LostFocus, _
                                                                            txt_TrigSensitivity.LostFocus, _
                                                                            txt_PlaySpeed.LostFocus, _
                                                                            txt_PlaySpeedRandom.LostFocus, _
                                                                            txt_PlaySpeedMin.LostFocus, _
                                                                            txt_OutDevice.LostFocus, _
                                                                            chk_Play.LostFocus, _
                                                                            chk_Stereo.LostFocus, _
                                                                            tk_Pan.LostFocus, _
                                                                            tk_VolumeUP.LostFocus, _
                                                                            tk_VolumeDW.LostFocus, _
                                                                            chk_FilterEnabled.LostFocus, _
                                                                            tk_FilterFreq.LostFocus, _
                                                                            tk_FilterRes.LostFocus, _
                                                                            tk_FilterDrive.LostFocus, _
                                                                            chk_EchoEnabled.LostFocus, _
                                                                            tk_EchoVolume.LostFocus, _
                                                                            tk_EchoFbk.LostFocus, _
                                                                            tk_EchoDelay.LostFocus
        If Not EventsAreEnabled Then Exit Sub
        Save_INI()
    End Sub



    ' ================================================================================================
    '   SLOTS
    ' ================================================================================================
    Private Sub txt_SlotIn_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_SlotIn.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        tk_Position.Value = 0
        Set_SlotProps()
    End Sub
    Private Sub txt_SlotInChange_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_SlotInChange.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_SlotProps()
    End Sub
    Private Sub txt_SlotOut_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_SlotOut.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_SlotProps()
    End Sub
    Private Sub txt_SlotOutChange_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_SlotOutChange.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_SlotProps()
    End Sub
    Private Sub txt_SlotPan_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_SlotPan.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        tk_Pan.Value = 5000
        Set_SlotProps()
    End Sub
    Private Sub txt_SlotVolUp_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_SlotVolUp.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_SlotProps()
    End Sub
    Private Sub txt_SlotVolDw_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_SlotVolDw.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_SlotProps()
    End Sub
    Private Sub txt_SlotFilterFreq_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_SlotFilterFreq.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_SlotProps()
    End Sub
    Private Sub txt_SlotFilterRes_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_SlotFilterRes.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_SlotProps()
    End Sub
    Private Sub txt_SlotEchoVolume_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_SlotEchoVolume.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_SlotProps()
    End Sub
    Private Sub txt_SlotEchoFbk_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_SlotEchoFbk.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_SlotProps()
    End Sub
    Private Sub Set_SlotProps()
        Slot_Input = txt_SlotIn.NumericValueInteger
        Slot_InputChange = txt_SlotInChange.NumericValueInteger
        Slot_Output = txt_SlotOut.NumericValueInteger
        Slot_OutputChange = txt_SlotOutChange.NumericValueInteger
        Slot_Pan = txt_SlotPan.NumericValueInteger
        Slot_VolUp = txt_SlotVolUp.NumericValueInteger
        Slot_VolDw = txt_SlotVolDw.NumericValueInteger
        Slot_FilterFreq = txt_SlotFilterFreq.NumericValueInteger
        Slot_FilterRes = txt_SlotFilterRes.NumericValueInteger
        Slot_EchoVolume = txt_SlotEchoVolume.NumericValueInteger
        Slot_EchoFbk = txt_SlotEchoFbk.NumericValueInteger
    End Sub


    ' ======================================================================================================
    '  MAIN PROPS
    ' ======================================================================================================
    Private Sub tk_Position_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tk_Position.Scroll
        If Not EventsAreEnabled Then Exit Sub
        Set_DesiredPos()
    End Sub
    Private Sub chk_Change_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_Change.CheckedChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_MainProps()
    End Sub
    Private Sub chk_Random_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_Random.CheckedChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_MainProps()
    End Sub
    Private Sub TabControl1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TabControl1.SelectedIndexChanged
        If Not EventsAreEnabled Then Exit Sub
        PlayStop()
        Set_MainProps()
        Save_INI()
        TriggerStarted = False
        PlayStart()
    End Sub
    Private Sub txt_ResponseSpeed_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_ResponseSpeed.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_MainProps()
    End Sub
    Private Sub txt_Margin_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_Margin.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_MainProps()
    End Sub
    Private Sub txt_MaxSpeedUP_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_MaxSpeedUP.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_MainProps()
    End Sub
    Private Sub txt_MaxSpeedDW_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_MaxSpeedDW.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_MainProps()
    End Sub
    Private Sub chk_Follow_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_Follow.CheckedChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_MainProps()
    End Sub
    Private Sub chk_Loop_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_Looping.CheckedChanged
        If Not EventsAreEnabled Then Exit Sub
        'PlayStop()
        Set_MainProps()
        'PlayStart()
    End Sub
    Private Sub Set_MainProps()
        With wfp
            .DesiredPos = tk_Position.Value / 10000.0F
            .ResponseSpeed = txt_ResponseSpeed.NumericValueInteger
            .Margin = txt_Margin.NumericValueInteger
            .MaxSpeedUP = txt_MaxSpeedUP.NumericValue
            .MaxSpeedDW = txt_MaxSpeedDW.NumericValue
            .Follow = chk_Follow.Checked
            .Looping = chk_Looping.Checked
        End With
        ' ---------------------------------------------------- 
        ChangeFile = chk_Change.Checked
        ChangeRandom = chk_Random.Checked
        ' ---------------------------------------------------- enable disable Margin
        lbl_Margin.Enabled = chk_Follow.Checked
        txt_Margin.Enabled = chk_Follow.Checked
        ' ---------------------------------------------------- enable disable Random
        chk_Random.Enabled = chk_Change.Checked
    End Sub

    Private Sub Set_DesiredPos()
        wfp.DesiredPos = tk_Position.Value / 10000.0F
    End Sub


    ' ======================================================================================================
    '  OUT PROPS
    ' ======================================================================================================
    Private Sub TabControl2_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TabControl2.SelectedIndexChanged
        If Not EventsAreEnabled Then Exit Sub
        Save_INI()
    End Sub
    Private Sub txt_OutDevice_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_OutDevice.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        PlayStop()
        Dim devCount As Int32 = WaveNative.OutputDevicesCount
        If txt_OutDevice.NumericValueInteger >= devCount Then
            txt_OutDevice.NumericValueInteger = devCount - 1
        End If
        wfp.OutDevice = txt_OutDevice.NumericValueInteger
        PlayStart()
    End Sub
    Private Sub chk_Stereo_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_Stereo.CheckedChanged
        If Not EventsAreEnabled Then Exit Sub
        PlayStop()
        Set_StereoEnable()
        PlayStart()
    End Sub
    Private Sub tk_Pan_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tk_Pan.Scroll
        If Not EventsAreEnabled Then Exit Sub
        If tk_Pan.Value > 4500 And tk_Pan.Value < 5500 Then
            tk_Pan.Value = 5000
            tk_Pan.Refresh()
        End If
        Set_OutProps()
    End Sub
    Private Sub tk_VolumeUP_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tk_VolumeUP.Scroll
        If Not EventsAreEnabled Then Exit Sub
        Set_OutProps()
    End Sub
    Private Sub tk_VolumeDW_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tk_VolumeDW.Scroll
        If Not EventsAreEnabled Then Exit Sub
        Set_OutProps()
    End Sub
    Private Sub Set_StereoEnable()
        ' ---------------------------------------------------- enable disable PAN
        tk_Pan.Enabled = chk_Stereo.Checked
        tk_Pan.Refresh()
        lbl_Pan1.Visible = chk_Stereo.Checked
        lbl_Pan2.Visible = chk_Stereo.Checked
    End Sub
    Private Sub Set_OutProps()
        With wfp
            .OutDevice = txt_OutDevice.NumericValueInteger
            .Pan = tk_Pan.Value / 5000.0F - 1.0F
            .VolumeUP = tk_VolumeUP.Value / 10000.0F
            .VolumeDW = tk_VolumeDW.Value / 10000.0F
        End With
    End Sub

    ' ====================================================================================================
    '   COMBO FILTER TYPE
    ' ====================================================================================================
    Private Sub cmb_PinType_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_FilterType.DropDown
        Combo_SetIndex_FromString(cmb_FilterType, cmb_FilterType.Text)
    End Sub
    Private Sub cmb_PinType_IntTypes()
        With cmb_FilterType
            .Items.Clear()
            .Items.Add("Lowpass")
            .Items.Add("Highpass")
            .Items.Add("Bandpass")
            .Items.Add("Notch")
        End With
    End Sub
    Private Sub cmb_PinType_SelectionChangeCommitted(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_FilterType.SelectionChangeCommitted
        Combo_SetIndex(cmb_FilterType, cmb_FilterType.SelectedIndex)
        Set_FilterProps()
        Save_INI()
    End Sub

    ' ======================================================================================================
    '  FILTER PROPS
    ' ======================================================================================================
    Private Sub chk_FilterEnabled_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_FilterEnabled.CheckedChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_FilterEnable()
    End Sub
    Private Sub tk_FilterFreq_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tk_FilterFreq.Scroll
        If Not EventsAreEnabled Then Exit Sub
        Set_FilterProps()
    End Sub
    Private Sub tk_FilterRes_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tk_FilterRes.Scroll
        If Not EventsAreEnabled Then Exit Sub
        Set_FilterProps()
    End Sub
    Private Sub tk_FilterDrive_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tk_FilterDrive.Scroll
        If Not EventsAreEnabled Then Exit Sub
        Set_FilterProps()
    End Sub
    Private Sub Set_FilterEnable()
        With wfp.Effects
            .SetFilterEnable(chk_FilterEnabled.Checked)
        End With
        ' ---------------------------------------------------- enable disable Filter-TrackBars
        Dim en As Boolean = chk_FilterEnabled.Checked
        tk_FilterFreq.Enabled = en
        tk_FilterRes.Enabled = en
        tk_FilterDrive.Enabled = en
        lbl_Filter1.Enabled = en
        lbl_Filter2.Enabled = en
        lbl_Filter3.Enabled = en
        cmb_FilterType.Enabled = en
        cmb_FilterType.BackColor = If(en, Color.MintCream, Color.FromArgb(220, 220, 220))
    End Sub
    Private Sub Set_FilterProps()
        With wfp.Effects
            .SetFilterType(cmb_FilterType.SelectedIndex)
            .SetFilterFrequency(tk_FilterFreq.Value / 10000.0F)
            .SetFilterResonance(tk_FilterRes.Value / 10000.0F)
            .SetFilterDrive(tk_FilterDrive.Value / 10000.0F)
        End With
    End Sub


    ' ======================================================================================================
    '  ECHO PROPS
    ' ======================================================================================================
    Private Sub chk_EchoEnabled_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_EchoEnabled.CheckedChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_EchoEnable()
    End Sub
    Private Sub tk_EchoVolume_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tk_EchoVolume.Scroll
        If Not EventsAreEnabled Then Exit Sub
        Set_EchoProps()
    End Sub
    Private Sub tk_EchoFbk_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tk_EchoFbk.Scroll
        If Not EventsAreEnabled Then Exit Sub
        Set_EchoProps()
    End Sub
    Private Sub tk_EchoDelay_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tk_EchoDelay.Scroll
        If Not EventsAreEnabled Then Exit Sub
        Set_EchoProps()
    End Sub
    Private Sub Set_EchoEnable()
        With wfp.Effects
            .SetEchoEnable(chk_EchoEnabled.Checked)
        End With
        ' ---------------------------------------------------- enable disable Filter-TrackBars
        tk_EchoVolume.Enabled = chk_EchoEnabled.Checked
        tk_EchoFbk.Enabled = tk_EchoVolume.Enabled
        tk_EchoDelay.Enabled = tk_EchoVolume.Enabled
        lbl_Echo1.Enabled = tk_EchoVolume.Enabled
        lbl_Echo2.Enabled = tk_EchoVolume.Enabled
        lbl_Echo3.Enabled = tk_EchoVolume.Enabled
    End Sub
    Private Sub Set_EchoProps()
        With wfp.Effects
            .SetEchoVolume(tk_EchoVolume.Value / 10000.0F)
            .SetEchoFeedback(tk_EchoFbk.Value / 10000.0F)
            .SetEchoDelay(tk_EchoDelay.Value / 10000.0F)
        End With
    End Sub


End Class